package org.jenkinsci.plugins.p4_client.workspace;

import hudson.DescriptorExtensionList;
import hudson.ExtensionPoint;
import hudson.model.Describable;
import hudson.model.Hudson;

public abstract class Workspace implements ExtensionPoint,
		Describable<Workspace> {

	private String nodeName;
	private String projectName;
	private String rootPath;

	public abstract WorkspaceType getType();

	public abstract String getName();
	
	public abstract String getCharset();

	public WorkspaceDescriptor getDescriptor() {
		return (WorkspaceDescriptor) Hudson.getInstance().getDescriptor(
				getClass());
	}

	public static DescriptorExtensionList<Workspace, WorkspaceDescriptor> all() {
		return Hudson.getInstance()
				.<Workspace, WorkspaceDescriptor> getDescriptorList(
						Workspace.class);
	}

	public String getNodeName() {
		return nodeName;
	}

	public String getProjectName() {
		return projectName;
	}

	public String getRootPath() {
		return rootPath;
	}

	public void setNodeName(String nodeName) {
		this.nodeName = nodeName;
	}

	public void setProjectName(String projectName) {
		this.projectName = projectName;
	}

	public void setRootPath(String rootPath) {
		this.rootPath = rootPath;
	}

}
